package bookExamples.ch26Graphics.draw2d;

import java.awt.*;
import java.awt.geom.Point2D;

/**
 * Created by IntelliJ IDEA.
 * User: Gino Lopes
 * Date: Feb 12, 2005
 * Time: 5:16:33 PM
 * To change this template use File | Settings | File Templates.
 * /

 /*Creates a cone based on the starting mouse click as the center of cone.*/

class Cone2d extends DJShape {
    int x1 = 0;
    int y1 = 0;
    int diameter = 1;
    int radius = 1;
    double radiusSq;
    int startAngle = 180;
    int arcAngle = 180;

    public DJShape getInstance(int x1, int y1, int x2, int y2) {
        Cone2d cone2d = new Cone2d(x1, y1, x2, y2);

        cone2d.setAffineTransform(getAffineTransform());
        //end of added code

        return cone2d;
    }// end getInstance()

    public Cone2d(int _x1, int _y1, int _x2, int _y2) {
        super(_x1, _y1, _x2, _y2);
        x1 = _x1;
        y1 = _y1;
        int dx = x1 - _x2;
        int dy = y1 - _y2;
        diameter = (int) Math.sqrt(dx * dx + dy * dy);
        if (_x1 > _x2) x1 = _x2;
        if (_y1 > _y2) y1 = _y2;
        radius = diameter / 2;
        radiusSq = radius * radius;
    }// end Cone2d()

    public void draw(Graphics g) {

        //beginning of code added
        Point2D pc = getCenter();
        int x = (int) pc.getX();
        int y = (int) pc.getY();
        Graphics2D g2d = (Graphics2D) g;


        // calculates the three points to draw cone sides
        CircleFcn cf = new CircleFcn(x, y, radius);
        double v = (0.25 + 1 / 3.0);
        Point2D p1 = cf.getPoint(1 - 0.25);
        Point2D p2 = cf.getPoint(1 - v);
        Point2D p3 = cf.getPoint(1 - (v + 1 / 3.0));

        // creates cone arc
        Point2D p4 = cf.getPoint(1 - 0.75);
        double w = Math.abs(p3.getX() - p2.getX());
        double h = Math.abs(p4.getY() - p2.getY());

        // draws the cone and lines for cone sides
        g2d.drawArc((int) p2.getX(), (int) p2.getY() - (int) h / 2, (int) w, (int) h, startAngle, arcAngle);
        drawLine(p1, p2, g);
        drawLine(p3, p1, g);

        // displays center point of cone
        g2d.fillOval(x, y, 2, 2);
        g2d.drawString("(" + x + "," + y + ")", x + 3, y + 3);

    }// end paint()

    public Point getCenter() {
        return new Point(x1, y1);
    }// end getCenter()

} // end class Cone2d
